import java.net.*;
import java.io.*;

public class CoordinazioneServer extends Thread{
	Socket ricez=null;
	DataInputStream in=null;
	MioServer parent;
	String user,pass,mode;
	int set,fil,pos,count;
			
	CoordinazioneServer(MioServer sup,Socket nuova){
		parent=sup;
		ricez=nuova;
	}
	
	public void run(){
		
		try{
				BufferedInputStream bis=new BufferedInputStream(ricez.getInputStream());
				in=new DataInputStream(bis);
				//Ricevo dati
				//user=in.readUTF(); eventuale user di server2
				//pass=in.readUTF();	eventuale pass di server2
				mode=in.readUTF();
		}catch(IOException e){
			System.err.println("Server2 down\n");
		};
		parent.info.append("Connessione server2:  "+mode+"\n");
		if(mode.equals("START"))AggiornaServer();
		else if(mode.equals("ORD")) RicezOrdine();
	}
	
	public void AggiornaServer(){
		try{
				//invio aggiornamento settori
				DataOutputStream out=new DataOutputStream(new BufferedOutputStream(ricez.getOutputStream()));
				for(int s=0;s<4;s++)
					for(int p=0;p<20;p++){
						out.writeInt(parent.Set[s].pos[p]);
						out.writeUTF(parent.Set[s].user[p]);
						out.writeInt(parent.Set[s].count[p]);
					}
				out.flush();
				out.close();
				in.close();
				ricez.close();
			}catch(IOException e){
			System.err.println("Server2 down\n");
			};
			parent.info.append("Aggiornamento totale di server2 completato.\n");
	}	
	
	public void RicezOrdine(){
		int posto;
		boolean stato,mio;
		
		//leggo ulteriori info
		try{
				user=in.readUTF();
				pass=in.readUTF();
				set=in.readInt();
				fil=in.readInt();
				pos=in.readInt();
				count=in.readInt();
		}catch(IOException e){
				System.err.println("Server2 down\n");
		}
		posto=pos+fil*5;
		mio=parent.Set[set].setPosto(posto,user,count);
		if(mio)	stato=true;
		else {
			parent.info.append("Problema di coerenza dei database!!");
			stato=false;
		}
		try{
			DataOutputStream out=new DataOutputStream(new BufferedOutputStream(ricez.getOutputStream()));
			out.writeBoolean(stato);
			out.flush();
			in.close();
			out.close();
			ricez.close();
		}catch(IOException e){
			System.err.println("Server2 down\n");
		}
	}
}	
	