import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class GestoreClient implements ActionListener{
	MioClient parent;
	String Hit;
	char Set='A';
	static boolean InvioInCorso=false;
	
	GestoreClient(MioClient sup){
		parent=sup;
	}
	
	public void actionPerformed(ActionEvent evt){
		Object Hit=evt.getSource();
		if(Hit instanceof JRadioButton)
				this.updateSettore(Hit);
		if(Hit instanceof JButton)
			if(!InvioInCorso){
				InvioInCorso=true;
				parent.Selezione.fil=(parent.menuFil.getSelectedIndex());
				parent.Selezione.pos=(parent.menuPos.getSelectedIndex());
				if(libero()){
					this.salvaInvio();
					parent.info.append("Invio per Set: "+Set+" F:"+(parent.Selezione.fil+1)+" P:"+
										(parent.Selezione.pos+1)+"\n");
					InvioClient InvioRichiesta=new InvioClient(parent,"RIC");
  				InvioRichiesta.start();
				}
				else {
					InvioInCorso=false;
					parent.info.append("Il posto  gi occupato.\n");
				}	
			}else parent.info.append("Attendere: op. gi in corso\n");
	}
	
	public void updateSettore(Object sett){
		if(sett==parent.cha){
			parent.Selezione.set=0;
			parent.imgPosti.setSettore(parent.Posto[0]);
			Set='A';
		}
		if(sett==parent.chb){
			parent.Selezione.set=1;
			parent.imgPosti.setSettore(parent.Posto[1]);
			Set='B';
		}
		if(sett==parent.chc){
			parent.Selezione.set=2;
			parent.imgPosti.setSettore(parent.Posto[2]);
			Set='C';
		}
		if(sett==parent.chd){
			parent.Selezione.set=3;
			parent.imgPosti.setSettore(parent.Posto[3]);
			Set='D';
		}
	}
	
	boolean libero(){
		if (parent.Posto[parent.Selezione.set][(parent.Selezione.fil)*5+
																	parent.Selezione.pos]==0)
				return true;
		else return false;
	}
	
	
	public void salvaInvio(){
		//salvo su invio.dat
		try{
			parent.info.setText("Salvo invio su file.\n");
			FileOutputStream file=new FileOutputStream("invio.dat");
			BufferedOutputStream buff=new BufferedOutputStream(file);
			DataOutputStream data=new DataOutputStream(buff);
			data.writeUTF(parent.Selezione.user);
			data.writeUTF(parent.Selezione.pass);
			data.writeInt(parent.Selezione.set);
			data.writeInt(parent.Selezione.fil);
			data.writeInt(parent.Selezione.pos);
			data.writeInt(parent.Selezione.count);
			data.close();
		}catch(IOException e){
			System.out.println("Errore - "+e.toString());
		};
		parent.info.append("Salvato\n");
	}
}