import java.net.*;
import java.io.*;

public class InAscolto extends Thread{
	MioServer parent;
	ServerSocket ascolto;
	String mode;
	
	public InAscolto(MioServer sup,int port,String come){
		super("InAscolto");
		mode=come.toString();
		parent=sup;
		try{
			ascolto=new ServerSocket(port);
		}catch(IOException e){
			System.err.println("Impossibile creare socket: "+e.toString());
			System.exit(1);
		};
		if(mode.equals("CLI")) parent.info.append("Server attivo...\n");
	}
	
	public void run(){
		Socket newSock=null;
		
		while(true){
			if(ascolto==null) return;
			try{
					newSock=ascolto.accept();
			}catch(IOException e){
			System.err.println("Impossibile connettersi al socket client: "+e.toString());
			System.exit(1);
			};
			if(mode.equals("CLI")){
			GestisciRicezione ric=new GestisciRicezione(parent,newSock);
			ric.start();
			}else{
				CoordinazioneServer cord=new CoordinazioneServer(parent,newSock);
				cord.start();
			}
		};
	}
}