import java.io.*;
import java.net.*;
import java.util.Random;

public class InvioClient extends Thread{
	MioClient parent;
	String Server,AltroServer,mode;
	int port,Altraport;
	DataOutputStream out;
	DataInputStream in;
	int set,fil,pos,count;
	
	InvioClient(MioClient superiore,String come){
		parent=superiore;
		mode=come;
		set=parent.Selezione.set;
		fil=parent.Selezione.fil;
		pos=parent.Selezione.pos;
		count=parent.Selezione.count;
	}
	
	public void run() {
		if(mode.equals("AGG")) InizializzaSett();
		else if(mode.equals("VER")) Recovery();
				 else if(mode.equals("RIC"))InviaRichiesta();
	}
	
	public void InizializzaSett(){
		Socket soc=null;
		int caso;
		Random rand=new Random();
		
		caso=Math.abs(rand.nextInt())%2;
		
		
		if(caso==0){
				Server=parent.msgS1.getText();
				port=Integer.parseInt(parent.msgP1.getText());
				AltroServer=parent.msgS2.getText();
				Altraport=Integer.parseInt(parent.msgP2.getText());
		}else{
			AltroServer=parent.msgS1.getText();
			Altraport=Integer.parseInt(parent.msgP1.getText());
			Server=parent.msgS2.getText();
			port=Integer.parseInt(parent.msgP2.getText());
		}
		parent.info.append("Tento di connettermi con "+Server+"  port: "+port+"\n");
		//invio rich aggiornamento
		try{
				soc=new Socket(Server,port);
				BufferedOutputStream bos=new BufferedOutputStream(soc.getOutputStream());
				out=new DataOutputStream(bos);
				out.writeUTF(parent.Selezione.user);
				out.writeUTF(parent.Selezione.pass);
				out.writeUTF(mode);
				out.flush();
				//Ricevo dati
				BufferedInputStream bis=new BufferedInputStream(soc.getInputStream());
				in=new DataInputStream(bis);
				for(int s=0;s<4;s++)
					for(int p=0;p<20;p++)
						parent.Posto[s][p]=in.readInt();
				out.close();
				in.close();
				soc.close();
		}catch(IOException e){
				parent.info.append("Fallita!\n");
				parent.info.append("Tento di connettermi con "+AltroServer+"  port: "+Altraport+"\n");
				try{
						soc=new Socket(AltroServer,Altraport);
						BufferedOutputStream bos=new BufferedOutputStream(soc.getOutputStream());
						out=new DataOutputStream(bos);
						BufferedInputStream bis=new BufferedInputStream(soc.getInputStream());
						in=new DataInputStream(bis);
						out.writeUTF(parent.Selezione.user);
						out.writeUTF(parent.Selezione.pass);
						out.writeUTF(mode);
						out.flush();
						for(int s=0;s<4;s++)
							for(int p=0;p<20;p++)
								parent.Posto[s][p]=in.readInt();
						out.close();
						in.close();
						soc.close();
				}catch(IOException e2){
					System.err.println("Aggiornamento database locale impossibile:  "+
							e2.getMessage());
					System.exit(1);
				}
		}
		parent.info.append("Aggiornamento database locale completato.\n");
		parent.imgPosti.setSettore(parent.Posto[0]);
		return;
	}
		
		
	public void InviaRichiesta(){
		Socket soc=null;
		boolean stato;
		
		if(set<=1){
			Server=parent.msgS1.getText();
			port=Integer.parseInt(parent.msgP1.getText());
			AltroServer=parent.msgS2.getText();
			Altraport=Integer.parseInt(parent.msgP2.getText());
		}else{
			AltroServer=parent.msgS1.getText();
			Altraport=Integer.parseInt(parent.msgP1.getText());
			Server=parent.msgS2.getText();
			port=Integer.parseInt(parent.msgP2.getText());
		}
		parent.info.append("Tento di connettermi con   "+Server+"   port: "+port+"\n");
		//invio richiesta
		try{
				soc=new Socket(Server,port);
				BufferedOutputStream bos=new BufferedOutputStream(soc.getOutputStream());
				DataOutputStream out=new DataOutputStream(bos);
				out.writeUTF(parent.Selezione.user);
				out.writeUTF(parent.Selezione.pass);
				out.writeUTF(mode);
				out.writeInt(set);
				out.writeInt(fil);
				out.writeInt(pos);
				out.writeInt(count);
				out.flush();
				//Ricevo risultati
				BufferedInputStream bis=new BufferedInputStream(soc.getInputStream());
				DataInputStream in=new DataInputStream(bis);
				stato=in.readBoolean();
				if(stato){
						parent.info.append("Il posto  ora tuo.\n");
						parent.Posto[set][pos+fil*5]=1;
				}else {
						parent.info.append("Il posto  occupato.Aggiornamento settore.\n");
						for(int p=0;p<20;p++)
							parent.Posto[set][p]=in.readInt();
				}
				File f=new File("invio.dat");
				f.delete();
				out.close();
				in.close();
				soc.close();
		}catch(IOException e){
			parent.info.append("Fallita!\nTento di connettermi con   "+AltroServer+
						"   port: "+Altraport+"\n");
			//invio richiesta alternativa
			try{
				soc=new Socket(AltroServer,Altraport);
				BufferedOutputStream bos=new BufferedOutputStream(soc.getOutputStream());
				DataOutputStream out=new DataOutputStream(bos);
				out.writeUTF(parent.Selezione.user);
				out.writeUTF(parent.Selezione.pass);
				out.writeUTF("VER");
				out.writeInt(set);
				out.writeInt(fil);
				out.writeInt(pos);
				out.writeInt(count);
				out.flush();
				//Ricevo risultati
				BufferedInputStream bis=new BufferedInputStream(soc.getInputStream());
				DataInputStream in=new DataInputStream(bis);
				stato=in.readBoolean();
				if(stato){
						parent.info.append("Il posto  ora tuo.\n");
						parent.Posto[set][pos+fil*5]=1;
				}else {
						parent.info.append("Il posto  occupato.Aggiornamento settore.\n");
						for(int p=0;p<20;p++)
							parent.Posto[set][p]=in.readInt();
				}
				File f=new File("invio.dat");
				f.delete();
				out.close();
				in.close();
				soc.close();
			}catch(IOException e2){
					System.err.println("Collegamento impossibile:  "+
							e2.getMessage());
					parent.info.append("Collegamento impossibile.\n");
			}
		}
		parent.imgPosti.setSettore(parent.Posto[parent.Selezione.set]);
		parent.Gestore.InvioInCorso=false;
		return;
	}
	
	public void Recovery(){
		Socket soc=null;
		String user,pass;
		int set,fil,pos,count;
		boolean stato;
		
		try{
				FileInputStream file=new FileInputStream("invio.dat");
				BufferedInputStream buff=new BufferedInputStream(file);
				DataInputStream data=new DataInputStream(buff);
				user=data.readUTF();
				pass=data.readUTF();
				set=data.readInt();
				fil=data.readInt();
				pos=data.readInt();
				count=data.readInt();
				data.close();
		} catch(FileNotFoundException e2){
				System.err.println("File invio.dat inesistente: "+e2.toString());
				return;
		} catch(IOException e1){
				System.err.println("Errore di lettura sul file invio.dat: "+e1.toString());
				return;
		}
		if(set<=1){
			Server=parent.msgS1.getText();
			port=Integer.parseInt(parent.msgP1.getText());
			AltroServer=parent.msgS2.getText();
			Altraport=Integer.parseInt(parent.msgP2.getText());
		}else{
			AltroServer=parent.msgS1.getText();
			Altraport=Integer.parseInt(parent.msgP1.getText());
			Server=parent.msgS2.getText();
			port=Integer.parseInt(parent.msgP2.getText());
		}
		parent.info.append("Tento di connettermi con   "+Server+"   port: "+port+"\n");
		//invio richiesta
		try{
				soc=new Socket(Server,port);
				BufferedOutputStream bos=new BufferedOutputStream(soc.getOutputStream());
				DataOutputStream out=new DataOutputStream(bos);
				out.writeUTF(user);
				out.writeUTF(pass);
				out.writeUTF(mode);
				out.writeInt(set);
				out.writeInt(fil);
				out.writeInt(pos);
				out.writeInt(count);
				out.flush();
				//Ricevo risultati
				BufferedInputStream bis=new BufferedInputStream(soc.getInputStream());
				DataInputStream in=new DataInputStream(bis);
				stato=in.readBoolean();
				if(stato) {
						char Set='~';
						switch(set){
							case (0):Set='A';
							case (1):Set='B';
							case (2):Set='C';
							case (3):Set='D';
						}
						parent.info.append("Recovery:Il posto "+Set+" F:"+(fil+1)+
									" P:"+(pos+1)+"\n");
						parent.Posto[set][pos+fil*5]=1;
				}else {
					parent.info.append("Precedente transazione non completata.\nRiprovare\n");
					for(int p=0;p<20;p++)
							parent.Posto[parent.Selezione.set][p]=in.readInt();
				}
				out.close();
				in.close();
				soc.close();
				File f=new File("invio.dat");
				f.delete();
		}catch(IOException e){
			parent.info.append("Fallita!\nTento di connettermi con   "+AltroServer+
							"   port: "+Altraport+"\n");
			//invio richiesta alternativa
			try{
				soc=new Socket(AltroServer,Altraport);
				BufferedOutputStream bos=new BufferedOutputStream(soc.getOutputStream());
				DataOutputStream out=new DataOutputStream(bos);
				out.writeUTF(user);
				out.writeUTF(pass);
				out.writeUTF(mode);
				out.writeInt(set);
				out.writeInt(fil);
				out.writeInt(pos);
				out.writeInt(count);
				out.flush();
				//Ricevo risultati
				BufferedInputStream bis=new BufferedInputStream(soc.getInputStream());
				DataInputStream in=new DataInputStream(bis);
				stato=in.readBoolean();
				if(stato) {
						parent.info.append("Recovery:Il posto "+(pos+fil*5)+"  tuo.\n");
						parent.Posto[set][pos+fil*5]=1;
				}else{
					parent.info.append("Precedente transazione non completata.\nRiprovare\n");
					for(int p=0;p<20;p++)
							parent.Posto[set][p]=in.readInt();
				}
				out.close();
				in.close();
				soc.close();
				File f=new File("invio.dat");
				f.delete();
			}catch(IOException e2){
					System.err.println("Collegamento impossibile:  "+
							e2.getMessage());
					parent.info.append("Collegamento impossibile.\n");
			}
		}
		parent.imgPosti.setSettore(parent.Posto[parent.Selezione.set]);
		parent.Gestore.InvioInCorso=false;
		return;
	}
}