import java.awt.event.*;
import javax.swing.*; 
import java.awt.*;
import java.awt.Image;
import java.awt.Graphics;
import java.io.*;
import java.net.*;


public class MioServer extends JFrame {
  JButton butVis=new JButton("Visualizza");
	JButton butCan=new JButton("Cancella");
	JButton butMod=new JButton("Settings");
	JButton butRes=new JButton("Reset data");
	JButton butOff=new JButton("Save data");
	JLabel spazio=new JLabel(" ");
	Sector[] Set=new Sector[4];
	CurrentSel Selezione=new CurrentSel();
	GestoreServer Gestore=new GestoreServer(this);
	JTextArea info=new JTextArea();
	JScrollPane panInfo=new JScrollPane(info);
	String Serv2;
	int Port2,MyPortC,MyPortS;
	finServ fin;
	String[] TrueUsers;
	String[] TruePass;
	int numUsers;
	InAscolto AttesaServ;
	InAscolto AttesaCli;
	
	
	
  public MioServer() {
  	super("Server");
  	//pannello principale
  	Set[0]=new Sector(this);
		Set[1]=new Sector(this);
		Set[2]=new Sector(this);
		Set[3]=new Sector(this);
  	JPanel pane=new JPanel();
  	pane.setBackground(Color.lightGray);
  	GridBagLayout grigliaScreen=new GridBagLayout();
  	GridBagConstraints limiti=new GridBagConstraints();
  	pane.setLayout(grigliaScreen);
  	//pannello info
  	buildConstraints(limiti,0,0,1,5,80,0);
  	info.setEditable(false);
  	limiti.fill=GridBagConstraints.BOTH;
  	grigliaScreen.setConstraints(panInfo,limiti);
  	pane.add(panInfo);
  	buildConstraints(limiti,1,0,1,1,5,0);
  	grigliaScreen.setConstraints(spazio,limiti);
  	pane.add(spazio);
  	buildConstraints(limiti,2,1,1,1,15,20);
  	limiti.fill=GridBagConstraints.HORIZONTAL;
  	limiti.anchor=GridBagConstraints.SOUTHEAST;
  	grigliaScreen.setConstraints(butVis,limiti);
  	butVis.addActionListener(Gestore);
  	pane.add(butVis);
  	buildConstraints(limiti,2,2,1,1,0,20);
  	limiti.fill=GridBagConstraints.HORIZONTAL;
  	limiti.anchor=GridBagConstraints.EAST;
  	grigliaScreen.setConstraints(butCan,limiti);
  	butCan.addActionListener(Gestore);
  	pane.add(butCan);
  	buildConstraints(limiti,2,0,1,1,0,20);
  	limiti.fill=GridBagConstraints.HORIZONTAL;
  	limiti.anchor=GridBagConstraints.EAST;
  	grigliaScreen.setConstraints(butMod,limiti);
  	butMod.addActionListener(Gestore);
  	pane.add(butMod);
  	buildConstraints(limiti,2,3,1,1,0,20);
  	limiti.fill=GridBagConstraints.HORIZONTAL;
  	limiti.anchor=GridBagConstraints.EAST;
  	grigliaScreen.setConstraints(butRes,limiti);
  	butRes.addActionListener(Gestore);
  	pane.add(butRes);
  	buildConstraints(limiti,2,4,1,1,0,20);
  	limiti.fill=GridBagConstraints.HORIZONTAL;
  	limiti.anchor=GridBagConstraints.EAST;
  	grigliaScreen.setConstraints(butOff,limiti);
  	butOff.addActionListener(Gestore);
  	pane.add(butOff);
  	setContentPane(pane);
  	//finestra di dialogo
  	fin=new finServ(this);
  	fin.resize(230,180);
  	fin.show();
  	//inizializzazione database
  	try{
  		Socket soc=new Socket(Serv2,Port2);
			BufferedOutputStream bos=new BufferedOutputStream(soc.getOutputStream());
			DataOutputStream out=new DataOutputStream(bos);
			out.writeUTF("START");
  		out.flush();
  		BufferedInputStream bis=new BufferedInputStream(soc.getInputStream());
			DataInputStream in=new DataInputStream(bis);
  		info.append("Inizializzo da server2\n");
  		for(int j=0;j<4;j++){
				for(int i=0;i<20;i++){
					Set[j].pos[i] = in.readInt();
					Set[j].user[i] = in.readUTF();
					Set[j].count[i] = in.readInt();
				}
  		}
  		out.close();
  		in.close();
  		soc.close();
  	}catch(IOException err){
  		this.inizSettFile();
  	}
  	this.VisualizzaPosti();
  	//apertura socket d'ascolto server
  	AttesaServ=new InAscolto(this,MyPortS,"SERV");
  	AttesaServ.start();
  	//lettura Users ammessi al servizio
  	info.append("Verifica utenti ammessi\n");
  	try {
  		File inFile = new File("Users.txt");
      FileInputStream inStream = new FileInputStream(inFile);
      byte[] data = new byte[(int)inFile.length()];
      if (inStream.read(data) <= 0) 
      	System.err.println("Errore: non posso leggere Users.dat");
  		
      for (int i = 0; i < data.length; i++)
      	if (data[i] == (byte)'\n') numUsers++;
      numUsers /= 2;
      TrueUsers = new String[numUsers];
      TruePass  = new String[numUsers];
  		
  		int start = 0, index = 0;
      boolean isU = true;
      for (int i = 0; i < data.length; i++)
      	if (data[i] == (byte)'\n') {
        	if (isU) {
        		TrueUsers[index] = new String(data, start, i - start - 1);
            isU = false;
          }else {
          	TruePass[index] = new String(data, start, i - start - 1);
            isU = true;
            index++;
          }
          start = i + 1;
        }
    }catch (FileNotFoundException e) {
    	System.err.println("Non trovo il file Users.dat");
    }
    catch (IOException e) {
      System.err.println("Errore di lettura sul file Users.dat");
    }
  	
  	for(int i=0;i<numUsers;i++)
  		//questa linea mostra users e password(solo per ricordarle)
  		System.out.println(TrueUsers[i]+"  "+TruePass[i]+"\n");
  	info.append("Ammessi "+numUsers+" utenti\n");
  	//Apertura socket d'ascolto client
  	AttesaCli=new InAscolto(this,MyPortC,"CLI");
    AttesaCli.start();
  	info.append("In attesa dei client...\n");
  }

    public static void main(String[] args) {
        final JFrame frame;
  			try {
            UIManager.setLookAndFeel(
                UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            System.err.println("Impossibile utilizzare lo stile "
                             + "di sistema: " + e);
        }

        frame = new MioServer();

        WindowListener l = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
              	frame.setVisible(false);
								frame.dispose();
								System.exit(0);
						}
        };
        frame.addWindowListener(l);
        frame.setSize(380,250);
    		frame.setResizable(false);
    		frame.setVisible(true);
    		
		}
		void buildConstraints(GridBagConstraints gbc,int gx,int gy,
								int gw,int gh,int wx,int wy){
			gbc.gridx=gx;
			gbc.gridy=gy;
			gbc.gridwidth=gw;
			gbc.gridheight=gh;
			gbc.weightx=wx;
			gbc.weighty=wy;
		}
	public void inizSettFile(){
	 	//simula
		String nome[]={"A.dat","B.dat","C.dat","D.dat"};
		info.append("Server2 down\n");
		for(int j=0;j<4;j++){
		info.append("Inizializzo da File "+nome[j]+"\n");
		try {
            FileInputStream file = new FileInputStream(nome[j]);
            BufferedInputStream buff=new BufferedInputStream(file);
						DataInputStream data=new DataInputStream(buff);
						for(int i=0;i<20;i++){
             	Set[j].pos[i] = data.readInt();
            	Set[j].user[i] = data.readUTF();
            	Set[j].count[i] = data.readInt();
            }
          	file.close();
						
		} catch (EOFException e2){
            System.err.println("File "+nome[j]+" non corretto");
            System.exit(1);
    } catch (IOException e) {
            System.out.println("Errore:  " + e.toString());
        		System.exit(1);
    }
		}
		return;
	}
	
	public void VisualizzaPosti(){
		int count=0;
		for(int j=0;j<4;j++){
			switch(j){
				case (0):
					info.append("Settore A\n");
					break;
				case (1):
					info.append("Settore B\n");
					break;
				case (2):
					info.append("Settore C\n");
					break;
				case (3):
					info.append("Settore D\n");
					break;
			}
			info.append("      F P\n");
			for(int f=1;f<=4;f++)
				for(int p=1;p<=5;p++){
					info.append("Posto "+f+" "+p+" : "+Set[j].pos[count]+"\n");
					count++;			
				};
			count=0;
		}
	}
	
	public Insets insets(){
		return new Insets(30,10,10,10);
	}
}